Package org.apache.storm.kafka.spout

# Enum Class FirstPollOffsetStrategy

java.lang.Object
java.lang.Enum<FirstPollOffsetStrategy>
org.apache.storm.kafka.spout.FirstPollOffsetStrategy

All Implemented Interfaces:
  `Serializable`, `Comparable<FirstPollOffsetStrategy>`, `Constable`

public enum FirstPollOffsetStrategy extends Enum<FirstPollOffsetStrategy>
Defines how the spout seeks the offset to be used in the first poll to Kafka upon topology deployment. By default this parameter is set to UNCOMMITTED_EARLIEST.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `EARLIEST`
  The kafka spout polls records starting in the first offset of the partition, regardless of previous commits.
  `LATEST`
  The kafka spout polls records starting at the end of the partition, regardless of previous commits.
  `TIMESTAMP`
  The kafka spout polls records starting at the earliest offset whose timestamp is greater than or equal to the given startTimestamp.
  `UNCOMMITTED_EARLIEST`
  The kafka spout polls records from the last committed offset, if any.
  `UNCOMMITTED_LATEST`
  The kafka spout polls records from the last committed offset, if any.
  `UNCOMMITTED_TIMESTAMP`
  The kafka spout polls records from the last committed offset, if any.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static FirstPollOffsetStrategy`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static FirstPollOffsetStrategy[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### EARLIEST

    public static final FirstPollOffsetStrategy EARLIEST
    The kafka spout polls records starting in the first offset of the partition, regardless of previous commits. This setting only takes effect on topology deployment

  - ### LATEST

    public static final FirstPollOffsetStrategy LATEST
    The kafka spout polls records starting at the end of the partition, regardless of previous commits. This setting only takes effect on topology deployment

  - ### TIMESTAMP

    public static final FirstPollOffsetStrategy TIMESTAMP
    The kafka spout polls records starting at the earliest offset whose timestamp is greater than or equal to the given startTimestamp. This setting only takes effect on topology deployment. This option is currently available only for the Trident Spout

  - ### UNCOMMITTED_EARLIEST

    public static final FirstPollOffsetStrategy UNCOMMITTED_EARLIEST
    The kafka spout polls records from the last committed offset, if any. If no offset has been committed it behaves as EARLIEST

  - ### UNCOMMITTED_LATEST

    public static final FirstPollOffsetStrategy UNCOMMITTED_LATEST
    The kafka spout polls records from the last committed offset, if any. If no offset has been committed it behaves as LATEST

  - ### UNCOMMITTED_TIMESTAMP

    public static final FirstPollOffsetStrategy UNCOMMITTED_TIMESTAMP
    The kafka spout polls records from the last committed offset, if any. If no offset has been committed it behaves as TIMESTAMP. This option is currently available only for the Trident Spout

- ## Method Details

  - ### values

    public static FirstPollOffsetStrategy[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static FirstPollOffsetStrategy valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null